diff -NurpP --minimal linux-2.4.25-vs1.26/Makefile linux-2.4.25-vs1.27/Makefile
--- linux-2.4.25-vs1.26/Makefile	2004-02-18 15:36:37.000000000 +0100
+++ linux-2.4.25-vs1.27/Makefile	2004-03-23 15:06:51.000000000 +0100
@@ -1,7 +1,7 @@
 VERSION = 2
 PATCHLEVEL = 4
 SUBLEVEL = 25
-EXTRAVERSION = -vs1.26
+EXTRAVERSION = -vs1.27
 
 KERNELRELEASE=$(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)
 
diff -NurpP --minimal linux-2.4.25-vs1.26/fs/ext2/ialloc.c linux-2.4.25-vs1.27/fs/ext2/ialloc.c
--- linux-2.4.25-vs1.26/fs/ext2/ialloc.c	2004-02-18 15:36:38.000000000 +0100
+++ linux-2.4.25-vs1.27/fs/ext2/ialloc.c	2004-03-23 15:06:51.000000000 +0100
@@ -386,9 +386,10 @@ repeat:
 	inode->i_blocks = 0;
 	inode->i_mtime = inode->i_atime = inode->i_ctime = CURRENT_TIME;
 	inode->u.ext2_i.i_state = EXT2_STATE_NEW;
-	inode->u.ext2_i.i_flags = dir->u.ext2_i.i_flags & ~EXT2_BTREE_FL;
+	inode->u.ext2_i.i_flags = dir->u.ext2_i.i_flags &
+		~(EXT2_BTREE_FL|EXT2_IMMUTABLE_LINK_FL);
 	if (S_ISLNK(mode))
-		inode->u.ext2_i.i_flags &= ~(EXT2_IMMUTABLE_FILE_FL|EXT2_IMMUTABLE_LINK_FL|EXT2_APPEND_FL);
+		inode->u.ext2_i.i_flags &= ~(EXT2_IMMUTABLE_FILE_FL|EXT2_APPEND_FL);
 	inode->u.ext2_i.i_block_group = group;
 	ext2_set_inode_flags(inode);
 	insert_inode_hash(inode);
diff -NurpP --minimal linux-2.4.25-vs1.26/fs/ext3/ialloc.c linux-2.4.25-vs1.27/fs/ext3/ialloc.c
--- linux-2.4.25-vs1.26/fs/ext3/ialloc.c	2004-02-18 15:36:38.000000000 +0100
+++ linux-2.4.25-vs1.27/fs/ext3/ialloc.c	2004-03-23 15:06:51.000000000 +0100
@@ -483,9 +483,10 @@ repeat:
 	inode->i_blksize = PAGE_SIZE;
 	inode->i_blocks = 0;
 	inode->i_mtime = inode->i_atime = inode->i_ctime = CURRENT_TIME;
-	inode->u.ext3_i.i_flags = dir->u.ext3_i.i_flags & ~EXT3_INDEX_FL;
+	inode->u.ext3_i.i_flags = dir->u.ext3_i.i_flags &
+		~(EXT3_INDEX_FL|EXT3_IMMUTABLE_LINK_FL);
 	if (S_ISLNK(mode))
-		inode->u.ext3_i.i_flags &= ~(EXT3_IMMUTABLE_FILE_FL|EXT3_IMMUTABLE_LINK_FL|EXT3_APPEND_FL);
+		inode->u.ext3_i.i_flags &= ~(EXT3_IMMUTABLE_FILE_FL|EXT3_APPEND_FL);
 #ifdef EXT3_FRAGMENTS
 	inode->u.ext3_i.i_faddr = 0;
 	inode->u.ext3_i.i_frag_no = 0;
diff -NurpP --minimal linux-2.4.25-vs1.26/include/linux/reiserfs_fs.h linux-2.4.25-vs1.27/include/linux/reiserfs_fs.h
--- linux-2.4.25-vs1.26/include/linux/reiserfs_fs.h	2004-02-19 00:48:07.000000000 +0100
+++ linux-2.4.25-vs1.27/include/linux/reiserfs_fs.h	2004-03-23 15:10:05.000000000 +0100
@@ -885,7 +885,6 @@ struct stat_data_v1
 
 /* persistent flags that file inherits from the parent directory */
 #define REISERFS_INHERIT_MASK ( REISERFS_IMMUTABLE_FILE_FL |	\
-				REISERFS_IMMUTABLE_LINK_FL |	\
 				REISERFS_SYNC_FL |	\
 				REISERFS_NOATIME_FL |	\
 				REISERFS_NODUMP_FL |	\
diff -NurpP --minimal linux-2.4.25-vs1.26/net/ipv4/af_inet.c linux-2.4.25-vs1.27/net/ipv4/af_inet.c
--- linux-2.4.25-vs1.26/net/ipv4/af_inet.c	2004-02-18 15:36:38.000000000 +0100
+++ linux-2.4.25-vs1.27/net/ipv4/af_inet.c	2004-03-23 15:06:51.000000000 +0100
@@ -513,8 +513,7 @@ int inet_bind(struct socket *sock, struc
 		} else if (s_addr == 0x0100007f) {
 			s_addr = s_addr1 = ipv4root;
 			ip_info = NULL;
-		} else if (s_addr != v4_bcast
-			&& s_addr != ipv4root) {
+               } else if (s_addr != v4_bcast) {
 			int i;
 			for (i=0; i<nbipv4; i++) {
 				if (s_addr == ip_info->ipv4[i])
diff -NurpP --minimal linux-2.4.25-vs1.26/net/socket.c linux-2.4.25-vs1.27/net/socket.c
--- linux-2.4.25-vs1.26/net/socket.c	2004-02-18 14:36:32.000000000 +0100
+++ linux-2.4.25-vs1.27/net/socket.c	2004-03-23 15:06:51.000000000 +0100
@@ -834,6 +834,10 @@ int sock_create(int family, int type, in
 	if (type < 0 || type >= SOCK_MAX)
 		return -EINVAL;
 
+	/* do not allow ipv6 inside vservers */
+	if (family == PF_INET6 && !vx_check(0, VX_ADMIN))
+		return -EAFNOSUPPORT;
+
 	/* Compatibility.
 
 	   This uglymoron is moved from INET layer to here to avoid
